include "include/client";
include "include/dotempmods";

global itemdefs := ReadConfigFile(":alchemy:itemdesc");
Const POISON_SOUND := 0x247;
Const DRINK_SOUND := 0x32;
Const UOBJ_EMPTY_BOTTLE := 0x0f0e;
Const EFFECT_BLUE_SPARKLE  := 0x373a;
Const SOUND_EFFECT_CURE	:= 0x1e1; 
Const EFFECT_SPARKLE  := 0x374a;
Const HIT_ACTION := 0x148b;
Const MOVING_EFFECT_PURPLE_POTION  := 0x0F0D; 
Const SOUND_EFFECT_EXPLOSION	:= 0x208; 
Const SOUND_EFFECT_HEAL	:= 0x1f3; 
Const EFFECT_EXPLOSION := 0x36b0;

function checkifcandrink(character)
	if ( cint(getobjproperty(character, "#potion")) > ReadGameClock()  )
		SendSysmessage(character, "You must wait until you can drink another potion!");
		return 0;
        else
                setobjproperty(character, "#potion", cint(ReadGameClock() + 20));
                return 1;
        endif
endfunction


function candrink(character)
        eraseobjproperty(character, "#potion");
endfunction

function empty_bottle(character, potion)

if (!ReserveItem(potion)) return; endif
	
    PlaySoundEffect (character, DRINK_SOUND);
    CreateItemInBackpack(character, UOBJ_EMPTY_BOTTLE, 1);
    SubtractAmount(potion, 1);
    PlayObjectCenteredEffect( character, EFFECT_BLUE_SPARKLE, 10,10);  

	ReleaseItem(potion);
    
endfunction

function get_potion_strength(potion)

	if (potion.objtype = 0x7059)
		return cint(GetObjProperty(potion,"strength"));
	else
		return cint(itemdefs[potion.objtype].strength);
	endif

endfunction

function is_poison(potion)

        local plevel := Cint(GetObjProperty(potion, "poison_level"));
        return plevel;

endfunction

function do_poison(character, potion)

	local potion_strength := is_poison(potion);
	if (Checkskill(character, SKILLID_ALCHEMY, (potion_strength * 15),  0 ))
                SendSysMessage(character, "That potion is poisonous!");
                return;
        endif

	empty_bottle(character, potion);

	SetPoison(character,potion_strength,"You've been poisoned!");

endfunction
