/////////////////////////////////////////////////////
// customspells.inc -- Simplified gate and recall code
//                     for use with runebook.src
//
// Author(s): Racalac
// Revisions: 1.0, 11/13/99: Gate, Recall
//                           Mana, Reagent consumption
//                           Normal Spell Restrictions
//
// Notes: (rev1.0) - None
//
// Dependencies: (rev1.0) - client.inc
//                          objtype.inc
//                          spellrestrictions.inc
//
/////////////////////////////////////////////////////

use uo;
use os;

include "include/objtype";
include "include/spelldata";

function custom_recall( caster , parms )

	if (!CanUseBook(caster))
		return 0;
	endif

        var x := parms[2];
        var y := parms[3];
        var z := parms[4];

	local shp := caster.hp;
	local sx := caster.x;
	local sy := caster.y;
	local sz := caster.z;
	local smana := caster.mana;
	
	local circle := 4;
	local delay := 2500;

        SpeakPowerWords( caster, SPELLID_RECALL );
	
	while ( delay > 500 )
		PerformAction(caster, ANIM_CASTING);
		delay := delay - 1000;
		sleep(1);
		if ((caster.hp < shp ) and (smana>70))
			Sendsysmessage( caster , "Your were interrupted while casting!");
			PlayObjectCenteredEffect(caster, FX_SPELL_FIZZLE, SPEED_SPELL_FIZZLE, LOOP_SPELL_FIZZLE);
			PlaySoundEffect(caster, SFX_SPELL_FIZZLE);
			return 0;
		endif
/*
		if (caster.x != sx or caster.y != sy or caster.z != sz)
			SendSysmessage( caster , "You've lost your concentration!" );
			PlayObjectCenteredEffect(caster, FX_SPELL_FIZZLE, SPEED_SPELL_FIZZLE, LOOP_SPELL_FIZZLE);
			PlaySoundEffect(caster, SFX_SPELL_FIZZLE);
			return 0;
		endif
*/
	endwhile

	sleepms(delay);
	if ((caster.hp < shp ) and (smana>70))
		Sendsysmessage( caster , "Your were interrupted while casting!");
		PlayObjectCenteredEffect(caster, FX_SPELL_FIZZLE, SPEED_SPELL_FIZZLE, LOOP_SPELL_FIZZLE);
		PlaySoundEffect(caster, SFX_SPELL_FIZZLE);
		return 0;
	endif

/*
	if (caster.x != sx or caster.y != sy or caster.z != sz)
		SendSysmessage( caster , "You've lost your concentration!" );
		PlayObjectCenteredEffect(caster, FX_SPELL_FIZZLE, SPEED_SPELL_FIZZLE, LOOP_SPELL_FIZZLE);
		PlaySoundEffect(caster, SFX_SPELL_FIZZLE);
		return 0;
	endif
*/

        if(!ConsumeReagents( caster, SPELLID_RECALL ))
	   	PrintTextAbovePrivate(caster,"*No reagents*", caster);
		PlayObjectCenteredEffect(caster, FX_SPELL_FIZZLE, SPEED_SPELL_FIZZLE, LOOP_SPELL_FIZZLE);
		PlaySoundEffect(caster, SFX_SPELL_FIZZLE);
           	return 0;
        endif

        if(!ConsumeMana( caster , SPELLID_RECALL ))
	   	PrintTextAbovePrivate(caster,"*No mana*", caster);
		PlayObjectCenteredEffect(caster, FX_SPELL_FIZZLE, SPEED_SPELL_FIZZLE, LOOP_SPELL_FIZZLE);
		PlaySoundEffect(caster, SFX_SPELL_FIZZLE);
           	return 0;
        endif

        if(!CheckSkill( caster , SKILL_MAGERY , GetSpellDifficulty(SPELLID_RECALL), 50 ) )
		PrintTextAbovePrivate(caster,"*The spell fizzle*", caster);
		PlayObjectCenteredEffect(caster, FX_SPELL_FIZZLE, SPEED_SPELL_FIZZLE, LOOP_SPELL_FIZZLE);
		PlaySoundEffect(caster, SFX_SPELL_FIZZLE);
           	return 0;
        endif

	if (!can_cast(caster, circle))
           return 0;
	endif

	local tox := x;
	local toy := y;
	local toz := z;

	PlaySoundEffect( caster, SFX_SPELL_RECALL1 );
	sleepms(250);
	MoveCharacterToLocation( caster, tox, toy, toz );
	PlaySoundEffect( caster, SFX_SPELL_RECALL2 );

        return 1;
endfunction


function custom_gate( caster, parms )

	if (!CanUseBook(caster))
		return 0;
	endif

	local shp := caster.hp;
	local sx := caster.x;
	local sy := caster.y;
	local sz := caster.z;
	local smana := caster.mana;

	local circle := 7;
	local delay := 4000;
        var x := parms[2];
        var y := parms[3];
        var z := parms[4];


        SpeakPowerWords( caster, SPELLID_GATE_TRAVEL );

	while ( delay > 500 )
		PerformAction(caster, ANIM_CASTING);
		delay := delay - 1000;
		sleep(1);
		if ((caster.hp < shp ) and (smana>70))
			Sendsysmessage( caster , "Your were interrupted while casting!");
			PlayObjectCenteredEffect(caster, FX_SPELL_FIZZLE, SPEED_SPELL_FIZZLE, LOOP_SPELL_FIZZLE );
			PlaySoundEffect(caster, SFX_SPELL_FIZZLE);
			return 0;
		endif
/*
		if (caster.x != sx or caster.y != sy or caster.z != sz)
			SendSysmessage( caster , "You've lost your concentration!" );
			PlayObjectCenteredEffect(caster, FX_SPELL_FIZZLE, SPEED_SPELL_FIZZLE, LOOP_SPELL_FIZZLE );
			PlaySoundEffect(caster, SFX_SPELL_FIZZLE);
			return 0;
		endif
*/
	endwhile

	sleepms(delay);

	if ((caster.hp < shp ) and (smana>70))
		Sendsysmessage( caster , "Your were interrupted while casting!");
		PlayObjectCenteredEffect(caster, FX_SPELL_FIZZLE, SPEED_SPELL_FIZZLE, LOOP_SPELL_FIZZLE );
		PlaySoundEffect(caster, SFX_SPELL_FIZZLE);
		return 0;
	endif

/*
	if (caster.x != sx or caster.y != sy or caster.z != sz)
		SendSysmessage( caster , "You've lost your concentration!" );
		PlayObjectCenteredEffect(caster, FX_SPELL_FIZZLE, SPEED_SPELL_FIZZLE, LOOP_SPELL_FIZZLE );
		PlaySoundEffect(caster, SFX_SPELL_FIZZLE);
		return 0;
	endif
*/
        if(!ConsumeReagents( caster, SPELLID_GATE_TRAVEL ))
	   	PrintTextAbovePrivate(caster,"*No reagents!*", caster);
		PlayObjectCenteredEffect(caster, FX_SPELL_FIZZLE, SPEED_SPELL_FIZZLE, LOOP_SPELL_FIZZLE );
		PlaySoundEffect(caster, SFX_SPELL_FIZZLE);
           	return 0;
        endif

        if(!ConsumeMana( caster , SPELLID_GATE_TRAVEL ))
	   	PrintTextAbovePrivate(caster,"*No mana!*", caster);
		PlayObjectCenteredEffect(caster, FX_SPELL_FIZZLE, SPEED_SPELL_FIZZLE, LOOP_SPELL_FIZZLE );
		PlaySoundEffect(caster, SFX_SPELL_FIZZLE);
           	return 0;
        endif

        if(!CheckSkill( caster , SKILL_MAGERY, GetSpellDifficulty(SPELLID_GATE_TRAVEL), 50 ) )
		PlayObjectCenteredEffect(caster, FX_SPELL_FIZZLE, SPEED_SPELL_FIZZLE, LOOP_SPELL_FIZZLE );
		PlaySoundEffect(caster, SFX_SPELL_FIZZLE);
		SendSysmessage(caster, "The spell fizzles");
           	return 0;
        endif

	if (!can_cast(caster, circle))
           return 0;
	endif


	local tox := x;
	local toy := y;
	local toz := z;

	set_critical( 1 );
	local pregate := CreateItemAtLocation( caster.x, caster.y, caster.z, 0x1af3, 1 );
	pregate.facing := 1;
	PlaySoundEffect( caster, SFX_SPELL_GATE_TRAVEL );
	sleepms(1500);

	local gate1 := CreateItemAtLocation( caster.x, caster.y, caster.z, UOBJ_BLUE_MOONGATE, 1 );
	gate1.facing := 1;
	destroyitem(pregate);

	local gate2 := CreateItemAtLocation( tox, toy, toz, UOBJ_BLUE_MOONGATE, 1 );
	gate2.facing := 2;
	if (!gate1 or !gate2)
		DestroyItem(gate1);
		DestroyItem(gate2);
           return 0;
	endif

	SetObjProperty( gate1, "GateDestX", gate2.x );
	SetObjProperty( gate1, "GateDestY", gate2.y );
	SetObjProperty( gate1, "GateDestZ", gate2.z );
	SetObjProperty( gate2, "GateDestX", gate1.x );
	SetObjProperty( gate2, "GateDestY", gate1.y );
	SetObjProperty( gate2, "GateDestZ", gate1.z );

	Detach();

	set_critical( 0 );

	PlaySoundEffect( caster, SFX_SPELL_GATE_TRAVEL );

	sleep(30);
    
	set_critical(1);
	DestroyItem( gate1 );
	DestroyItem( gate2 );
	set_critical(0);

        return(1);
endfunction

function CanUseBook(me)

	local cfg := readconfigfile(":combat:itemdesc");
	local item;

	local theweapon := GetEquipmentByLayer( me,  0x01   );
	local theweapon2 := GetEquipmentByLayer( me,  0x02   );

	if ((!theweapon) and (!theweapon2))
		return 1;
	endif

	local weapon1 := cfg[theweapon.objtype].blocksCastingIfInHand;
	local weapon2 := cfg[theweapon2.objtype].blocksCastingIfInHand;
	
	if (weapon1=0 and !theweapon2)
	return 1;
	elseif (weapon2=0 and !theweapon)
	return 1;
	elseif (weapon1=0 and weapon2=0)
	return 1;
	endif

	PrintTextAbovePrivate(me,"Your hands must be free to use that!",me);
	return 0;

endfunction
