const GFX_UNSHORN_SHEEP := 0xcf;
const GFX_SHORN_SHEEP := 0xdf;

function main_AI_loop()

    local ev;
    local wanders := 60;
    local next_wander := 0;
    local next_regrow := readgameclock()+cint(RandomInt(1800));
    local nextbark := readgameclock() + 30;

    CheckSheepAmount();
    EnableMainEvents();

	local mydestx := 0;
	local mydesty := 0;
	local steps := 0;

    while (1)

	if (readgameclock() > next_wander)

		if (mydestx != 0)
			WalkTowardLocation(mydestx, mydesty);
			if ( (me.x = mydestx and me.y = mydesty) or ( steps > 10 ) )
				mydestx := 0;
			endif
		else	
			wander();
			wanders := wanders +1;
		endif

		next_wander := readgameclock()+5;
		if (wanders > 60)
			wanders :=0;
			ev := sleepmode();
	    	endif
	else
		ev := os::wait_for_event( 5 );
	endif

	if (ev)
        repeat
	    case (ev.type)
                EVID_DAMAGED:
                EVID_ENGAGED:
		    RunLikeHell( ev.source );
		EVID_ALL_FOLLOW_CMD:
			mydestx := ev.x;
			mydesty := ev.y;
			steps := 0;
			drop_anchor();
			WalkTowardLocation(mydestx, mydesty);
            endcase
        until (! (ev := os::wait_for_event(1)) );
	endif

	if (readgameclock() > next_regrow)
		next_regrow := readgameclock()+cint(1800+RandomInt(300));
		if ( me.graphic = GFX_SHORN_SHEEP )
			me.graphic := GFX_UNSHORN_SHEEP;
		endif
		CheckSheepAmount();
	endif

	if ( readgameclock() > nextbark )
		nextbark := readgameclock() + ( (randomint(5)+1) * 60 );
		case (randomint(2))
		0: PlaySoundEffect(me,0xD7);
		1: PlaySoundEffect(me,0xD8);
		endcase
	endif

   endwhile      

endfunction        

function RunLikeHell(opponent)

	local ev, sleepdelay;
	while ( (opponent) and not 
	    (opponent.dead or opponent.hidden or opponent.concealed) and 
	    (distance(me,opponent) < 10) ) 
	        sleepdelay := 300 - (CInt(me.dexterity) * 1.5);
  		if (sleepdelay < 0) sleepdelay := 0; endif
	    Runawayfrom( opponent );
		Sleepms(sleepdelay);
        repeat
	    case (ev.type)
                EVID_DAMAGED:
		    if ( randomint(3) = 1 )
                    	Fight( ev.source );
		    	return;
                    endif
            endcase
        until (! (ev := os::wait_for_event(1)) );

	endwhile

endfunction

function look_around()

	return;

endfunction

function EnableMainEvents()

    DisableEvents( EVID_ENTEREDAREA + EVID_SPEECH + EVID_LEFTAREA + EVID_DISENGAGED + EVID_OPPONENT_MOVED);
    EnableEvents( EVID_ENGAGED + EVID_DAMAGED, HALT_THRESHOLD );

endfunction

function DisableMainEvents()

    DisableEvents( EVID_ENGAGED + EVID_DAMAGED);

endfunction

function CheckSheepAmount()

	local DeathChance := -4;
	Foreach npc in ListMobilesNearLocation(me.x, me.y, me.z, 4)
		if (npc.npctemplate = "sheep")
			deathchance := deathchance + 5;
		endif
	endforeach

	if ( RandomInt(500) < DeathChance )			
		damage( me, me.maxhp + 3 );
	endif

endfunction
