use uo;
use os;
use npc;
use util;
use basic;
use cfgfile;
include "include/client";
include "include/dotempmods";

function castspell( caster, cast_on, spellname )

	case (spellname)
	"summonskel": 
		SummonSkel(caster,cast_on);
	
	default:
		local SpellID := GetSpellID(spellname);
		if (!spellID)
			return;
		endif

		If (!PrepareToCast(caster,cast_on,spellid))
			return;
		endif

		local parms array;
		parms[1] := "#MOB";
		parms[2] := caster;
		parms[3] := cast_on;

		detach();

		start_script( ":spells:"+spellname, parms ); 
	endcase

endfunction

function SummonSkel(me, onwho)

	local timescasted := GetObjProperty(me, "timescasted");

	if ((!timescasted) or (timescasted<>"")) timescasted :=0; endif

	timescasted := timescasted +1;
	SetObjProperty(me, "timescasted", timescasted);

	if (timescasted>=2) return; endif

	local utterance := randomint(4);
	local magery := GetSkill(me, SKILLID_MAGERY);
	local duration := 20 + (magery * 2);

	case (utterance)
        	0: say("Awake, my children! Come forth and take your rightful place!");
        	1: say("Come forth my minions!");
        	2: say("I call upon the forces of darkness to attend me!");
        	3: say("Mortal, you shall soon be my slave!");
	endcase

	summoncritter( me, "skeleton", duration);
	summoncritter( onwho, "zombie"  , duration);
	summoncritter( me, "skeleton", duration);

endfunction

function summoncritter( who, thecreature, duration )

	local thecritter := createnpcfromtemplate(thecreature, who.x+randomint(1), who.y+randomint(1), who.z, 0);
	Setobjproperty(thecritter, "guardkill", 1);
	SetObjProperty(thecritter, "summoned",1);
	detach();
	sleep(duration);
	PlaySoundEffect( thecritter , SFX_SPELL_MANA_VAMPIRE );
	PlayObjectCenteredEffect( thecritter, 0x3728, 8);
	MoveCharacterToLocation(thecritter,5445,1153,0,MOVECHAR_FORCELOCATION);

	damage (thecritter, thecritter.hp + 3);

endfunction

Function GetSpellID(spellname)

	local spellid := 0;

	case (spellname)
	"clumsy"	: spellid := 1;
	"feeblemind"	: spellid := 3;
	"heal"		: spellid := 4;
	"magicarrow"	: spellid := 5;
	"reactivearmor"	: spellid := 7;
	"weaken"	: spellid := 8;
	"agility"	: spellid := 9;
	"cunning"	: spellid := 10;
	"cure"		: spellid := 11;
	"harm"		: spellid := 12;
	"protection"	: spellid := 15;
	"strength"	: spellid := 16;
	"bless"		: spellid := 17;
	"fireball"	: spellid := 18;
	"poison"	: spellid := 20;
	"teleport"	: spellid := 22;
	"wallofstone"	: spellid := 24;
	"archcure"	: spellid := 25;
	"archprot"	: spellid := 26;
	"curse"		: spellid := 27;
	"firefield"	: spellid := 28;
	"gheal"		: spellid := 29;
	"lightning"	: spellid := 30;
	"manadrain"	: spellid := 31;
	"blade_spirit"	: spellid := 33;
	"dispel_field"	: spellid := 34;
	"reflect"	: spellid := 36;
	"mindblast"	: spellid := 37;
	"paralyze"	: spellid := 38;
	"poisonfield"	: spellid := 39;
	"summon_creature": spellid := 40;
	"dispel"	: spellid := 41;
	"ebolt"		: spellid := 42;
	"explosion"	: spellid := 43;
	"invisibility"	: spellid := 44;
	"masscurse"	: spellid := 46;
	"parafield"	: spellid := 47;
	"reveal"	: spellid := 48;
	"chain_lightning": spellid := 49;
	"energy_field"	: spellid := 50;
	"fstrike"	: spellid := 51;
	"manavamp"	: spellid := 53;
	"massdispel"	: spellid := 54;
	"meteor_swarm"	: spellid := 55;
	"polymorph"	: spellid := 56;
	"earthquake"	: spellid := 57;
	"vortex"	: spellid := 58;
	"resurrect"	: spellid := 59;
	"summon_air"	: spellid := 60;
	"summon_daemon"	: spellid := 61;
	"summon_earth"	: spellid := 62;
	"summon_fire"	: spellid := 63;
	"summon_water"	: spellid := 64;
	endcase

	return spellid;
	
endfunction

function PrepareToCast(caster, cast_on, spellid)

	if (!CheckLineOfSight( caster, cast_on ))
		return 0;
	endif

	if (saywords)
		SpeakPowerWords( me, spellid);
		PerformAction(caster,ANIM_CAST_DIR);
		sleep(1);
	endif

	if (GetSkill(caster, SKILLID_MAGERY))
		if (!CheckSkill(caster, SKILLID_MAGERY, GetSpellDifficulty( spellid ), 100))
			PlaySoundEffect(caster,0x005d);
			PlayObjectCenteredEffect(caster, 0x3735,10, 30);
			return 0;
		endif
	endif

	if (! ConsumeMana( caster, spellid ))
		return 0;
	endif

	return 1;

endfunction

function cast_offensive_spell(caster, cast_on)

	local thespell := spells[randomint( len(spells) +1 )];

	CastSpell(caster, cast_on, thespell);

endfunction
