//////////////////////////////////////////////////////////////////////////////////
//										//
//	spelldata.inc : 							//
//										//
//	This file include all the constant related to existing spells, as	//
//	well as useful fuction about spells. The first line of each spell	//
//	is the spellid, then his SFX anf finally his FX				//
//										//
//////////////////////////////////////////////////////////////////////////////////


const SPELLID_RECALL		:= 32;
const SFX_SPELL_RECALL1  	:= 0x0210;
const SFX_SPELL_RECALL2		:= 0x01fd;
const SPELLID_GATE_TRAVEL	:= 52;

const ANIM_CASTING       	:= 0x0010;      // Spellcasting direction.
const FX_SPELL_FIZZLE		:= 0x3735; 	// Fizzle a spell FX
const SPEED_SPELL_FIZZLE	:= 7;		//Speed for fizzling effect
const LOOP_SPELL_FIZZLE		:= 7;		//Loop for fizzling effect
const SFX_SPELL_FIZZLE		:= 0x05b;	// Fizzling a spell SFX
const SKILL_MAGERY            	:= 25;

/*

///////////////////////
//        All        //
///////////////////////

const ANIM_CASTING       	:= 0x0010;      // Spellcasting direction.
const ANIM_CASTING_AREA      	:= 0x0011;      // Spellcasting area.
const SFX_SPELL_FIZZLE		:= 0x05b;	// Fizzling a spell SFX
const FX_SPELL_FIZZLE		:= 0x3735; 	// Fizzle a spell FX
const MOVING_SPELL_FIZZLE	:= 0;
const SPEED_SPELL_FIZZLE	:= 7;		//Speed for fizzling effect
const LOOP_SPELL_FIZZLE		:= 7;		//Loop for fizzling effect


const CORPSE_OBJTYPE		:= 0x2006;	// Objtype of a corpse

///////////////////////
// 1st Circle Spells //
///////////////////////

//Clumsy
const SPELLID_CLUMSY  		:= 1;
const SFX_SPELL_CLUMSY 		:= 0x01e0;
const FX_SPELL_CLUMSY		:= 0x374a;
const MOVING_SPELL_CLUMSY	:= 0;
const SPEED_SPELL_CLUMSY	:= 7;
const LOOP_SPELL_CLUMSY		:= 7;

//Create Food
const SPELLID_CREATE_FOOD	:= 2;
const SFX_SPELL_CREATE_FOOD	:= 0x01e3;
				// Have no FX

//Feeblemind
const SPELLID_FEEBLEMIND	:= 3;
const SFX_SPELL_FEEBLEMIND      := 0x01e5;
const FX_SPELL_FEEBLEMIND   	:= 0x374a;
const MOVING_SPELL_FEEBLEMIND	:= 0;
const SPEED_SPELL_FEEBLEMIND	:= 7;
const LOOP_SPELL_FEEBLEMIND	:= 7;

//Heal
const SPELLID_HEAL		:= 4;
const SFX_SPELL_HEAL            := 0x01f3;
const FX_SPELL_HEAL    		:= 0x376a;
const MOVING_SPELL_HEAL		:= 0;
const SPEED_SPELL_HEAL		:= 7;
const LOOP_SPELL_HEAL		:= 0x10;

//Magic Arrow
const SPELLID_MAGIC_ARROW	:= 5;
const SFX_SPELL_MAGIC_ARROW     := 0x01e6;
const FX_SPELL_MAGIC_ARROW    	:= 0x36e4;
const MOVING_SPELL_MAGIC_ARROW 	:= 1;
const SPEED_SPELL_MAGIC_ARROW  	:= 5;
const LOOP_SPELL_MAGIC_ARROW	:= 1;

//Night Sight
const SPELLID_NIGHTSIGHT	:= 6;
const SFX_SPELL_NIGHT_SIGHT     := 0x01e4;
const FX_SPELL_NIGHT_SIGHT   	:= 0x373a;
const MOVING_SPELL_NIGHT_SIGHT 	:= 0;
const SPEED_SPELL_NIGHT_SIGHT  	:= 10;
const LOOP_SPELL_NIGHT_SIGHT	:= 10;

//Reactive Armor
const SPELLID_REACTIVE_ARMOR	:= 7;
const SFX_SPELL_REACTIVE_ARMOR  := 0x01f3;
const FX_SPELL_REACTIVE_ARMOR	:= 0x373a;
const MOVING_SPELL_REACTIVE_ARMOR 	:= 0;
const SPEED_SPELL_REACTIVE_ARMOR  	:= 5;
const LOOP_SPELL_REACTIVE_ARMOR		:= 5;

//Weaken
const SPELLID_WEAKEN		:= 8;
const SFX_SPELL_WEAKEN          := 0x01e7;
const FX_SPELL_WEAKEN	   	:= 0x374a;
const MOVING_SPELL_WEAKEN	:= 0;
const SPEED_SPELL_WEAKEN	:= 7;
const LOOP_SPELL_WEAKEN		:= 7;


///////////////////////
// 2nd Circle Spells //
///////////////////////

//Agility
const SPELLID_AGILITY		:= 9;
const SFX_SPELL_AGILITY         := 0x01e8;
const FX_SPELL_AGILITY 		:= 0x373a;
const MOVING_SPELL_AGILITY	:= 0;
const SPEED_SPELL_AGILITY	:= 7;
const LOOP_SPELL_AGILITY	:= 7;

//Cunning
const SPELLID_CUNNING		:= 10;
const SFX_SPELL_CUNNING         := 0x01ec;
const FX_SPELL_CUNNING   	:= 0x373a;
const MOVING_SPELL_CUNNING	:= 0;
const SPEED_SPELL_CUNNING	:= 7;
const LOOP_SPELL_CUNNING	:= 7;

//Cure
const SPELLID_CURE		:= 11;
const SFX_SPELL_CURE            := 0x01e1;
const FX_SPELL_CURE   		:= 0x373a;
const MOVING_SPELL_CURE		:= 0;
const SPEED_SPELL_CURE		:= 10;
const LOOP_SPELL_CURE		:= 10;

//Harm
const SPELLID_HARM		:= 12;
const SFX_SPELL_HARM            := 0x01f2;
const FX_SPELL_HARM		:= 0x37c3;
const MOVING_SPELL_HARM		:= 0;
const SPEED_SPELL_HARM		:= 0x0a;
const LOOP_SPELL_HARM		:= 0x1e;

//Magic Trap
const SPELLID_MAGIC_TRAP	:= 13;
const SFX_SPELL_MAGIC_TRAP1 	:= 0x01f0;
const SFX_SPELL_MAGIC_TRAP2 	:= 0x0236;
				// Unknow FX

//Magic Untrap
const SPELLID_MAGIC_UNTRAP	:= 14;
const SFX_SPELL_MAGIC_UNTRAP1	:= 0x01f1;
const SFX_SPELL_MAGIC_UNTRAP2	:= 0x011f;
				// Unknow FX

//Protection
const SPELLID_PROTECTION	:= 15;
const SFX_SPELL_PROTECTION      := 0x01ee;
const FX_SPELL_PROTECTION	:= 0x373a;
const MOVING_SPELL_PROTECTION	:= 0;
const SPEED_SPELL_PROTECTION	:= 7;
const LOOP_SPELL_PROTECTION	:= 7;

//Strength
const SPELLID_STRENGTH		:= 16;
const SFX_SPELL_STRENGTH        := 0x01ef;
const FX_SPELL_STRENGTH		:= 0x373a;
const MOVING_SPELL_STRENGTH	:= 0;
const SPEED_SPELL_STRENGTH	:= 7;
const LOOP_SPELL_STRENGTH	:= 7;


///////////////////////
// 3rd Circle Spells //
///////////////////////

//Bless
const SPELLID_BLESS		:= 17;
const SFX_SPELL_BLESS           := 0x01eb;
const FX_SPELL_BLESS   		:= 0x373a;
const MOVING_SPELL_BLESS	:= 0;
const SPEED_SPELL_BLESS		:= 10;
const LOOP_SPELL_BLESS		:= 10;

//Fireball
const SPELLID_FIREBALL		:= 18;
const SFX_SPELL_FIREBALL        := 0x0160;
const FX_SPELL_FIREBALL		:= 0x36d4;
const MOVING_SPELL_FIREBALL	:= 1;
const SPEED_SPELL_FIREBALL	:= 5;
const LOOP_SPELL_FIREBALL	:= 1;

//Magic Lock
const SPELLID_MAGIC_LOCK	:= 19;
const SFX_SPELL_MAGIC_LOCK1	:= 0x01f5;
const SFX_SPELL_MAGIC_LOCK2	:= 0x011f;
				// Unknow FX

//Poison
const SPELLID_POISON		:= 20;
const SFX_SPELL_POISON          := 0x0247;
const FX_SPELL_POISON	   	:= 0x374a;
const MOVING_SPELL_POISON	:= 0;
const SPEED_SPELL_POISON	:= 0x0a;
const LOOP_SPELL_POISON		:= 0x1e;

//Telekinesis
const SPELLID_TELEKINESIS	:= 21;
const SFX_SPELL_TELEKINESIS     := 0x01f6;
				// No FX

//Teleport
const SPELLID_TELEPORT		:= 22;
const SFX_SPELL_TELEPORT        := 0x01ff;
const FX_SPELL_TELEPORT		:= 0x3728;
const MOVING_SPELL_TELEPORT	:= 0;
const SPEED_SPELL_TELEPORT	:= 0xa;
const LOOP_SPELL_TELEPORT	:= 0xa;

//Unlock
const SPELLID_UNLOCK		:= 23;
const SFX_SPELL_UNLOCK1  	:= 0x0200;
const SFX_SPELL_UNLOCK2  	:= 0x011f;
				// Unknow FX

//Wall of Stone
const SPELLID_WALL_OF_STONE	:= 24;
const SFX_SPELL_WALL_OF_STONE   := 0x01f7;
				// No FX (Create the Wall)


///////////////////////
// 4th Circle Spells //
///////////////////////

//Arch Cure
const SPELLID_ARCH_CURE		:= 25;
const SFX_SPELL_ARCH_CURE       := 0x01e9;
const FX_SPELL_ARCH_CURE	:= 0x373a;
const MOVING_SPELL_ARCH_CURE	:= 0;
const SPEED_SPELL_ARCH_CURE	:= 10;
const LOOP_SPELL_ARCH_CURE	:= 10;

//Arch Protection
const SPELLID_ARCH_PROTECTION	:= 26;
const SFX_SPELL_ARCH_PROTECTION := 0x01f8;
const FX_SPELL_ARCH_PROTECTION	:= 0x373a;
const MOVING_SPELL_ARCH_PROTECTION	:= 0;
const SPEED_SPELL_ARCH_PROTECTION	:= 7;
const LOOP_SPELL_ARCH_PROTECTION	:= 7;

//Curse
const SPELLID_CURSE		:= 27;
const SFX_SPELL_CURSE           := 0x01e2;
const FX_SPELL_CURSE	   	:= 0x374a;
const MOVING_SPELL_CURSE	:= 0;
const SPEED_SPELL_CURSE		:= 10;
const LOOP_SPELL_CURSE		:= 10;

//Fire Field
const SPELLID_FIRE_FIELD	:= 28;
const SFX_SPELL_FIRE_FIELD      := 0x0226;
const FX_SPELL_FIRE_FIELD_EW    := 0x398c;
const FX_SPELL_FIRE_FIELD_NS    := 0x3996;

//Greater Heal
const SPELLID_GREATER_HEAL	:= 29;
const SFX_SPELL_GREATER_HEAL    := 0x0203;
const FX_SPELL_GREATER_HEAL   	:= 0x375a;
const MOVING_SPELL_GREATER_HEAL	:= 0;
const SPEED_SPELL_GREATER_HEAL	:= 7;
const LOOP_SPELL_GREATER_HEAL	:= 0x10;

//Lightning
const SPELLID_LIGHTNING		:= 30;
const SFX_SPELL_LIGHTNING       := 0x02a;
const MOVING_SPELL_LIGHTNING	:= 2;
	// For FX use :		PlayLightningBoltEffect(cast_on); from UO.em

//Mana Drain
const SPELLID_MANA_DRAIN	:= 31;
const SFX_SPELL_MANA_DRAIN      := 0x01f9;
const FX_SPELL_MANA_DRAIN	:= 0x376a;
const MOVING_SPELL_MANA_DRAIN	:= 0;
const SPEED_SPELL_MANA_DRAIN	:= 7;
const LOOP_SPELL_MANA_DRAIN	:= 0x10;

//Recall
const SPELLID_RECALL		:= 32;
const SFX_SPELL_RECALL1  	:= 0x0210;
const SFX_SPELL_RECALL2		:= 0x01fd;
const SFX_SPELL_RECALL		:= 0x01fd;
				// No FX

///////////////////////
// 5th Circle Spells //
///////////////////////

//Blade Spirit
const SPELLID_BLADE_SPIRIT	:= 33;
const SFX_SPELL_BLADE_SPIRIT 	:= 0x0213;
const FX_SPELL_BLADE_SPIRIT	:= 0x3728;
const MOVING_SPELL_BLADE_SPIRIT := 0;
const SPEED_SPELL_BLADE_SPIRIT  := 0xa;
const LOOP_SPELL_BLADE_SPIRIT	:= 0xa;

//Dispel Field
const SPELLID_DISPEL_FIELD	:= 34;
const SFX_SPELL_DISPEL_FIELD    := 0x0202;
const FX_SPELL_DISPEL_FIELD	:= 0x3728;
const MOVING_SPELL_DISPEL_FIELD := 0;
const SPEED_SPELL_DISPEL_FIELD  := 0xa;
const LOOP_SPELL_DISPEL_FIELD	:= 0xa;

//Incognito
const SPELLID_INCOGNITO		:= 35;
const SFX_SPELL_INCOGNITO       := 0x01e3;
				// No FX

//Spell Reflection
const SPELLID_MAGIC_REFLECTION	:= 36;
const SFX_SPELL_MAGIC_REFLECTION:= 0x01e8;
const FX_SPELL_MAGIC_REFLECTION := 0x374a;
const MOVING_SPELL_MAGIC_REFLECTION 	:= 0;
const SPEED_SPELL_MAGIC_REFLECTION  	:= 10;
const LOOP_SPELL_MAGIC_REFLECTION	:= 10;

//Mind Blast
const SPELLID_MIND_BLAST	:= 37;
const SFX_SPELL_MIND_BLAST      := 0x0214;
const FX_SPELL_MIND_BLAST 	:= 0x374a;
const MOVING_SPELL_MIND_BLAST 	:= 0;
const SPEED_SPELL_MIND_BLAST  	:= 7;
const LOOP_SPELL_MIND_BLAST	:= 0x10;

//Paralyze
const SPELLID_PARALYZE		:= 38;
const SFX_SPELL_PARALYZE        := 0x0205;
const FX_SPELL_PARALYZE 	:= 0x374a;
const MOVING_SPELL_PARALYZE 	:= 0;
const SPEED_SPELL_PARALYZE  	:= 10;
const LOOP_SPELL_PARALYZE	:= 0xa;

//Poison Field
const SPELLID_POISON_FIELD	:= 39;
				// No SFX
const FX_SPELL_POISON_FIELD_EW 	:= 0x3914;
const FX_SPELL_POISON_FIELD_NS 	:= 0x3920;

//Summon Creature
const SPELLID_SUMMON_CREATURE	:= 40;
const SFX_SPELL_SUMMON_CREATURE := 0x0216;
const FX_SPELL_SUMMON_CREATURE	:= 0x3728;
const MOVING_SPELL_SUMMON_CREATURE	:= 0;
const SPEED_SPELL_SUMMON_CREATURE	:= 0xa;
const LOOP_SPELL_SUMMON_CREATURE	:= 0xa;


///////////////////////
// 6th Circle Spells //
///////////////////////

//Dispel
const SPELLID_DISPEL		:= 41;
const SFX_SPELL_DISPEL          := 0x0202;
const FX_SPELL_DISPEL		:= 0x3728;
const MOVING_SPELL_DISPEL	:= 0;
const SPEED_SPELL_DISPEL	:= 0xa;
const LOOP_SPELL_DISPEL		:= 0xa;

//Energy Bolt
const SPELLID_ENERGY_BOLT	:= 42;
const SFX_SPELL_ENERGY_BOLT     := 0x020b;
const FX_SPELL_ENERGY_BOLT    	:= 0x379f;
const MOVING_SPELL_ENERGY_BOLT	:= 1;
const SPEED_SPELL_ENERGY_BOLT	:= 0xa;
const LOOP_SPELL_ENERGY_BOLT	:= 0x1e;

//Explosion
const SPELLID_EXPLOSION		:= 43;
const SFX_SPELL_EXPLOSION       := 0x0208;
const FX_SPELL_EXPLOSION      	:= 0x36b0;
const MOVING_SPELL_EXPLOSION	:= 0;
const SPEED_SPELL_EXPLOSION	:= 7;
const LOOP_SPELL_EXPLOSION	:= 0x10;

//Invisibility
const SPELLID_INVISIBILITY	:= 44;
const SFX_SPELL_INVISIBILITY    := 0x0204;
				// No FX

//Mark
const SPELLID_MARK		:= 45;
const SFX_SPELL_MARK            := 0x01fb;
const FX_SPELL_MARK    		:= 0x3779;
const MOVING_SPELL_MARK		:= 0;
const SPEED_SPELL_MARK		:= 10;
const LOOP_SPELL_MARK		:= 10;

//Mass Curse
const SPELLID_MASS_CURSE	:= 46;
const SFX_SPELL_MASS_CURSE      := 0x01fc;
const FX_SPELL_MASS_CURSE 	:= 0x374a;
const MOVING_SPELL_MASS_CURSE	:= 0;
const SPEED_SPELL_MASS_CURSE	:= 10;
const LOOP_SPELL_MASS_CURSE	:= 10;

//Paralyze Field
const SPELLID_PARALYZE_FIELD	:= 47;
const SFX_SPELL_PARALYZE_FIELD  := 0x020c;
const FX_SPELL_PARALYZE_FIELD_EW:= 0x3967;
const FX_SPELL_PARALYZE_FIELD_NS:= 0x3979;

//Reveal
const SPELLID_REVEAL		:= 48;
const SFX_SPELL_REVEAL          := 0x01fe;
				// No FX

///////////////////////
// 7th Circle Spells //
///////////////////////

//Chain Lightning
const SPELLID_CHAIN_LIGHTNING	:= 49;
const SFX_SPELL_CHAIN_LIGHTNING := 0x02a;
const MOVING_SPELL_CHAIN_LIGHTNING	:= 2;
	//For FX use :		PlayLightningBoltEffect(cast_on); from UO.em

//Energy Field
const SPELLID_ENERGY_FIELD	:= 50;
const SFX_SPELL_ENERGY_FIELD    := 0x0211;
const UOBJ_ENERGY_FIELD_EW  	:= 0x3947;
const UOBJ_ENERGY_FIELD_NS  	:= 0x3956;

//Flame Strike
const SPELLID_FLAME_STRIKE	:= 51;
const SFX_SPELL_FLAME_STRIKE    := 0x0209;
const FX_SPELL_FLAME_STRIKE    	:= 0x3709;
const MOVING_SPELL_FLAME_STRIKE	:= 0;
const SPEED_SPELL_FLAME_STRIKE	:= 0x0a;
const LOOP_SPELL_FLAME_STRIKE	:= 0x1e;

//Gate Travel
const SPELLID_GATE_TRAVEL	:= 52;
const SFX_SPELL_GATE_TRAVEL     := 0x020f;
				// No FX

//Mana Vampire
const SPELLID_MANA_VAMPIRE	:= 53;
const SFX_SPELL_MANA_VAMPIRE    := 0x01fa;
const FX_SPELL_MANA_VAMPIRE	:= 0x37b9;
const MOVING_SPELL_MANA_VAMPIRE	:= 0;
const SPEED_SPELL_MANA_VAMPIRE	:= 7;
const LOOP_SPELL_MANA_VAMPIRE	:= 0x10;

//Mass Dispel
const SPELLID_MASS_DISPEL	:= 54;
const SFX_SPELL_MASS_DISPEL     := 0x020a;
const FX_SPELL_MASS_DISPEL	:= 0x3728;
const MOVING_SPELL_MASS_DISPEL	:= 0;
const SPEED_SPELL_MASS_DISPEL	:= 0xa;
const LOOP_SPELL_MASS_DISPEL	:= 0xa;

//Meteor Swarm
const SPELLID_METEOR_SWARM	:= 55;
const SFX_SPELL_METEOR_SWARM    := 0x0161;
const FX_SPELL_METEOR_SWARM	:= 0x36d4;
const MOVING_SPELL_METEOR_SWARM	:= 1;
const SPEED_SPELL_METEOR_SWARM	:= 5;
const LOOP_SPELL_METEOR_SWARM	:= 1;

//Polymorph
const SPELLID_POLYMORPH		:= 56;
const SFX_SPELL_POLYMORPH       := 0x020a;
const FX_SPELL_POLYMORPH	:= 0x01fa;
const MOVING_SPELL_POLYMORPH	:= 0;
const SPEED_SPELL_POLYMORPH	:= 0xa;
const LOOP_SPELL_POLYMORPH	:= 0xa;


///////////////////////
// 8th Circle Spells //
///////////////////////

//Earthquake
const SPELLID_EARTHQUAKE	:= 57;
const SFX_SPELL_EARTHQUAKE	:= 0x020e;
const SFX_SPELL_EARTHQUAKE1     := 0x0220;
const SFX_SPELL_EARTHQUAKE2	:= 0x0223;
const FX_SPELL_EARTHQUAKE	:= 0x3728;
const MOVING_SPELL_EARTHQUAKE	:= 0;
const SPEED_SPELL_EARTHQUAKE	:= 7;
const LOOP_SPELL_EARTHQUAKE	:= 7;

//Energy Vortex
const SPELLID_ENERGY_VORTEX	:= 58;
const SFX_SPELL_ENERGY_VORTEX   := 0x0213;
const FX_SPELL_ENERGY_VORTEX	:= 0x3728;
const MOVING_SPELL_ENERGY_VORTEX	:= 0;
const SPEED_SPELL_ENERGY_VORTEX	:= 0xa;
const LOOP_SPELL_ENERGY_VORTEX	:= 0xa;

//Resurrection
const SPELLID_RESURRECTION	:= 59;
const SFX_SPELL_RESSURECTION    := 0x0215;
				// No FX

//Summon Air Elemental
const SPELLID_SUMMON_AIR_ELEMENTAL	:= 60;
const SFX_SPELL_SUMMON_AIR_ELEMENTAL   	:= 0x0218;
const SFX_SPELL_SUMMON_ELEMENTAL	:= 0x0218;
					// No FX

//Summon Daemon
const SPELLID_SUMMON_DAEMON	:= 61;
const SFX_SPELL_SUMMON_DAEMON   := 0x0217;
				// No FX

//Summon Earth Elemental
const SPELLID_SUMMON_EARTH_ELEMENTAL	:= 62;
const SFX_SPELL_SUMMON_EARTH_ELEMENTAL 	:= 0x0218;
					// No FX

//Summon Fire Elemental
const SPELLID_SUMMON_FIRE_ELEMENTAL	:= 63;
const SFX_SPELL_SUMMON_FIRE_ELEMENTAL  	:= 0x0218;
					// No FX

//Summon Water Elemental
const SPELLID_SUMMON_WATER_ELEMENTAL	:= 64;
const SFX_SPELL_SUMMON_WATER_ELEMENTAL 	:= 0x0218;
					// No FX


/////////////////////////////////
// Lesser Chants of Necromancy //
/////////////////////////////////

//Animate Dead
const SPELLID_ANIMATE_DEAD	:= 65;
const SFX_SPELL_ANIMATE_DEAD	:= 0x022b;
				// No FX
const ANIMATE_DEAD_CORPSE_COLOR	:= 0x482;

//Commune
const SPELLID_COMMUNE		:= 66;
const SFX_SPELL_COMMUNE		:= 0x024b;
				// No FX

//Control Undead
const SPELLID_CONTROL_UNDEAD	:= 67;
				// No SFX
				// No FX

//Darkness
const SPELLID_DARKNESS		:= 68;
const SFX_SPELL_DARKNESS	:= 0x01e4;
const FX_SPELL_DARKNESS		:= 0x0373a;

//Sacrifice
const SPELLID_SACRIFICE		:= 69;
const SFX_SPELL_SACRIFICE	:= 0x0208;
const FX_SPELL_SACRIFICE	:= 0x036b0;
	//Plus a :		PlayLightningBoltEffect(cast_on);

//Specter's Touch
const SPELLID_SPECTER_TOUCH	:= 70;
				//No SFX
				//No FX

//Wraith's Breath
const SPELLID_WRAITH_BREATH	:= 71;
const SFX_SPELL_WRAITH_BREATH	:= 0x1fa;
const FX_SPELL_WRAITH_BREATH	:= 0x374a;

//Wyvern Strike
const SPELLID_WYVERN_STRIKE	:= 72;
const SFX_SPELL_WYVERN_STRIKE	:= 0x1e2;
const FX_SPELL_WYVERN_STRIKE	:= 0x374a;


//////////////////////////////////
// Greater Chants of Necromancy //
//////////////////////////////////

//Raise Dead
const SPELLID_RAISE_DEAD	:= 73;
const SFX_SPELL_RAISE_DEAD	:= 0x022b;
				// No FX

//Release
const SPELLID_RELEASE		:= 74;
const SFX_SPELL_RELEASE		:= 0x1ec;
				// No FX

//Summon Spirit
const SPELLID_SUMMON_SPIRIT	:= 75;
const SFX_SPELL_SUMMON_SPIRIT	:= 0x022b;
				// No FX

//Wraithform
const SPELLID_WRAITHFORM	:= 76;
const WRAITHFORM_DRAIN_SOUND	:= 0x1fa;
const WRAITHFORM_MORPH_SOUND	:= 0x210;
const WRAITHFORM_WRAITH_GRAPHIC	:= 0x1a;
const WRAITHFORM_WRAITH_COLOR	:= 0x482;
const WRAITHFORM_DRAIN_EFFECT	:= 0x374a;
const WRAITHFORM_MORPH_EFFECT	:= 0x3709;

//Kill
const SPELLID_KILL		:= 77;
const SFX_SPELL_KILL		:= 0x202;
const FX_SPELL_KILL		:= 0x375a;

//Liche
const SPELLID_LICHE		:= 78;
const LICHE_KILL_SOUND 		:= 0x202;
const LICHE_MORPH_SOUND 	:= 0x20a;
const LICHE_KILL_EFFECT 	:= 0x375a;

//Plague
const SPELLID_PLAGUE		:= 79;
const SFX_SPELL_PLAGUE		:= 0x1e2;
const FX_SPELL_PLAGUE		:= 0x374a;

//Spellbind
const SPELLID_SPELLBIND		:= 80;
const SFX_SPELL_SPELLBIND	:= 0x20d;
				// No FX


//////////////////
// Earth Spells //
//////////////////

//Icestrike
const SFX_SPELL_ICESTRIKE1	:= 0x0117;
const SFX_SPELL_ICESTRIKE2	:= 0x0118;
const FX_SPELL_ICESTRIKE	:= 0x3789;
const MOVING_SPELL_ICESTRIKE	:= 0;
const SPEED_SPELL_ICESTRIKE	:= 30;
const LOOP_SPELL_ICESTRIKE	:= 30;


//////////////////////////////////////END OF SPELLS///////////////////////////////////



/////////////////////////////////////////////////
// SkillID that can be useful with some spells //
/////////////////////////////////////////////////

const SKILL_ALCHEMY           	:= 0;
const SKILL_ANATOMY           	:= 1;
const SKILL_ANIMALLORE        	:= 2;
const SKILL_DRUIDRY           	:= 2;
const SKILL_ITEMID            	:= 3;
const SKILL_ARMSLORE          	:= 4;
const SKILL_BATTLE_DEFENSE    	:= 5;
const SKILL_PARRY             	:= 5;
const SKILL_BEGGING           	:= 6;
const SKILL_BLACKSMITHY       	:= 7;
const SKILL_BOWCRAFT          	:= 8;
const SKILL_PEACEMAKING       	:= 9;
const SKILL_CAMPING           	:= 10;
const SKILL_CARPENTRY         	:= 11;
const SKILL_CARTOGRAPHY       	:= 12;
const SKILL_COOKING           	:= 13;
const SKILL_DETECTINGHIDDEN   	:= 14;
const SKILL_ENTICEMENT        	:= 15;
const SKILL_LEADERSHIP        	:= 15;
const SKILL_TAUNT             	:= 15;
const SKILL_EVALINT           	:= 16;
const SKILL_INVOCATION        	:= 16;
const SKILL_HEALING           	:= 17;
const SKILL_FISHING           	:= 18;
const SKILL_FORENSICS         	:= 19;
const SKILL_HERDING           	:= 20;
const SKILL_HIDING            	:= 21;
const SKILL_PROVOCATION       	:= 22;
const SKILL_INSCRIPTION       	:= 23;
const SKILL_LOCKPICKING       	:= 24;
const SKILL_MAGERY            	:= 25;
const SKILL_MAGICRESISTANCE   	:= 26;
const SKILL_TACTICS          	:= 27;
const SKILL_SNOOPING          	:= 28;
const SKILL_MUSICIANSHIP      	:= 29;
const SKILL_POISONING         	:= 30;
const SKILL_ARCHERY           	:= 31;
const SKILL_SPIRITSPEAK       	:= 32;
const SKILL_NECROMANCY        	:= 32;
const SKILL_STEALING          	:= 33;
const SKILL_TAILORING        	:= 34;
const SKILL_TAMING           	:= 35;
const SKILL_TASTEID           	:= 36;
const SKILL_TINKERING         	:= 37;
const SKILL_TRACKING          	:= 38;
const SKILL_VETERINARY        	:= 39;
const SKILL_SWORDSMANSHIP     	:= 40;
const SKILL_MACEFIGHTING      	:= 41;
const SKILL_FENCING           	:= 42;
const SKILL_WRESTLING         	:= 43;
const SKILL_LUMBERJACKING     	:= 44;
const SKILL_MINING            	:= 45;
const SKILL_MEDITATION        	:= 46;
const SKILL_STEALTH           	:= 47;
const SKILL_REMOVETRAP        	:= 48;
const SKILL__HIGHEST  		:= 48;

//////////////////////////////////////END OF SKILLID////////////////////////////////




//////////////////////////////////////END OF SOUNDS////////////////////////////////////

////////////////////////////////
// Spell functions' constants //
////////////////////////////////


const INTERRUPTED		:= 1;
const NO_REGS			:= 2;
const NO_MANA			:= 3;
const NO_SKILL			:= 4;
const SUCCESS			:= 5;

const IMMUNED			:= 1;
const CURSED			:= 2;

const FIRE			:= 1;
const AIR			:= 2;
const EARTH			:= 3;
const WATER			:= 4;
*/

//////////////////////////////////////////////////////////////////////////////////////////////////
// Spell functions :										//
//	This include all functions from spellrestrictions.inc, plus some more.			//
//	Don't erase the spellrestrictions however, unless you are certain that you changed	//
//	include "include/spellrestrictions" from ALL pkgs that used it.	Some parameters of	//
//	the functions changed however.								//			
//////////////////////////////////////////////////////////////////////////////////////////////////

use uo;
use os;
use cfgfile;
use util;


function can_cast ( me, circle )

	//if (getobjproperty(me, "team"))
	//	return 1;
	//endif

	//if (!getglobalproperty("restrictarmor"))
       	//	return 1;
	//endif

	//local cfg := ReadConfigFile( "::itemdesc" );
	//local item;

	//foreach item in ListEquippedItems(me)
      	//	if ( (cfg[item.objtype].blockcircle) && (cfg[item.objtype].blockcircle <= circle) )
	//		SendSysmessage(me, 
	//			       "Your equipment prevents you from casting this spell!");
        //        	return 0;
	//	endif
	//endforeach

	return 1;

endfunction


function CanTargetSpell ( caster, circle, TargOpt := TGTOPT_CHECK_LOS )

	if (!can_cast(caster, circle))
        	return 0;
	endif

	local cx := caster.x;
	local cy := caster.y;
	local shp := caster.hp;

	local cast_on := Target( caster, TargOpt );
	if(!cast_on  or !cast_on.strength)
		return;
	endif

	if ( (cx != caster.x) or (cy != caster.y) or (shp > caster.hp) )
		SendSysMessage(caster,"You've lost your concentration.");
		return 0;
	endif

	return cast_on;	

endfunction


function CanTargetArea (caster, circle)

	if (!can_cast(caster, circle))
        	return 0;
	endif

	local cx := caster.x;
	local cy := caster.y;
	local shp := caster.hp;

	local cast_loc := TargetCoordinates( caster );
	if (!cast_loc.x)
		return 0;
	endif

	if ( (cx != caster.x) or (cy != caster.y) or (shp > caster.hp) )
		SendSysMessage(caster,"You've lost your concentration.");
		return 0;
	endif

	if (!CheckLosAt( caster, cast_loc.x, cast_loc.y, cast_loc.z ))
        	SendSysMessage( caster, "You can't see that." );
		return 0;
	endif

	return cast_loc;	

endfunction


function Reflected ( caster , cast_on , circle )

	local source := caster;
	local targ := cast_on;
	local wasreflected;

        if ( SPELL_EFFECT_TYPE_MOVING = 1 )
        	PlayMovingEffect(source, 
                                 targ, 
                                 SPELL_EFFECT_ID, 
                                 SPELL_EFFECT_SPEED, 
                                 SPELL_EFFECT_LOOP, 
                                 explode := 0);
	endif

	local mrlevel := Cint( GetObjProperty( targ , "mr" ) );
	local permmr := Cint( GetObjProperty( targ , "Permmr" ) );
	if( !permmr )
		permmr := 0;
	endif
		
	local corrupmr := 0 - permmr;
	local protserial := Cint( GetObjProperty( targ , "#SpellReflect") );
	local item;
	local cursed;
	local charges;
	if( protserial )
		foreach thing in ListEquippedItems( targ )
			if ( thing.serial = protserial )
				item := thing;
				cursed := GetObjProperty( item , "Cursed" );
				charges := GetObjProperty( item , "SpellReflect" );
				if ( !charges )
					eraseobjproperty( targ ,"#SpellReflect");
					eraseobjproperty( item ,"SpellReflect" );
					PrintTextAbovePrivate( item , item.desc + " is out of charges!" , targ );
				endif
				break;
			endif
		endforeach
	endif	
	
		
	if( charges >= circle )
		charges := charges - circle;
		setobjproperty(item , "SpellReflect" , charges);
		if( !cursed )
			PrintTextAbovePrivate( targ , "Your " + item.desc + " reflected the spell!" , targ );
			source := cast_on;
			targ := caster;
			Reflect ( source , targ );
			ReflectBack( caster , cast_on , source , targ , circle );
			wasreflected := 1;
		else
			PrintTextAbovePrivate( targ , "Your " + item.desc + " prevent all reflections!" , targ );
		endif
	
	elseif ( corrupmr >= circle )
		PrintTextAbovePrivate( targ , "One of your item prevent all reflections!" , targ );
		
	elseif ( mrlevel >= circle )
		SetObjProperty( cast_on , "mr" , mrlevel - circle );
		source := cast_on;
		targ := caster;
		Reflect ( source , targ );
		ReflectBack( caster , cast_on , source , targ , circle );
		wasreflected := 1;

	elseif ( permmr >= circle )
		source := cast_on;
		targ := caster;
		Reflect ( source , targ );
		ReflectBack( caster , cast_on , source , targ , circle );
		wasreflected := 1;
	endif


	if ( wasreflected = 1 && targ = caster )
		SendSysmessage( caster , "The spell is reflected back to you!" );
	endif

        if (!SPELL_EFFECT_TYPE_MOVING)
		PlayObjectCenteredEffect(targ, 
                                         SPELL_EFFECT_ID,
                                         SPELL_EFFECT_SPEED,
                                         SPELL_EFFECT_LOOP);
	endif

        if (SPELL_EFFECT_TYPE_MOVING = 2)
		PlayLightningBoltEffect( targ );
	endif

	return targ;

endfunction


function Reflect ( source , targ )

	PlaySoundEffect( source , SFX_SPELL_MAGIC_REFLECTION );
	PlayObjectCenteredEffect( source , FX_SPELL_MAGIC_REFLECTION , SPEED_SPELL_MAGIC_REFLECTION , LOOP_SPELL_MAGIC_REFLECTION );
	SendSysMessage( source , "Your magic reflect spell saved you!" );
        if ( SPELL_EFFECT_TYPE_MOVING = 1 )
        	PlayMovingEffect(source, 
                                 targ, 
                                 SPELL_EFFECT_ID, 
                                 SPELL_EFFECT_SPEED, 
                                 SPELL_EFFECT_LOOP, 
                                 explode := 0);
        	sleep(2);
	endif

endfunction


function ReflectBack ( caster , cast_on , byref source , byref targ , circle )

	local mrlevel := Cint( GetObjProperty( targ , "mr" ) );
	local permmr := Cint( GetObjProperty( targ , "Permmr" ) );
	if( !permmr )
		permmr := 0;
	endif
	
	local corrupmr := 0 - permmr;
	local protserial := Cint( GetObjProperty( targ , "#SpellReflect") );
	local item;
	local cursed;
	local charges;
	
	if( protserial )
		foreach thing in ListEquippedItems( targ )
			if ( thing.serial = protserial )
				item := thing;
				cursed := GetObjProperty( item , "Cursed" );
				charges := GetObjProperty( item , "SpellReflect" );
				if ( !charges )
					eraseobjproperty( targ ,"#SpellReflect");
					eraseobjproperty(item,"SpellReflect");
					PrintTextAbovePrivate( item , item.desc + " is out of charges!" , targ );
				endif
				break;
			endif
		endforeach
	endif

		
	if( charges >= circle )
		charges := charges - circle;
		setobjproperty(item , "SpellReflect" , charges);
		if( !cursed )
			PrintTextAbovePrivate( targ , "Your " + item.desc + " reflected the spell!" , targ );
			source := caster;
			targ := cast_on;
			Reflect ( source , targ );
		else
			PrintTextAbovePrivate( targ , "Your " + item.desc + " prevent all reflections!" , targ );
		endif
		
	elseif ( corrupmr >= circle )
		PrintTextAbovePrivate( targ , "One of your item prevent all reflections!" , targ );
		
	elseif ( mrlevel >= circle )
		SetObjProperty( cast_on , "mr" , mrlevel - circle );
		source := caster;
		targ := cast_on;
		Reflect ( source , targ );


	elseif ( permmr >= circle )
		source := caster;
		targ := cast_on;
		Reflect ( source , targ );

	endif

	return;
	
endfunction


function Resisted ( caster , cast_on , circle , dmg )

	local multiplier;
	local points := ( circle * 100 );
	local magery := Cint( GetSkill( caster , SKILL_MAGERY ) );
	local evalint := Cint( GetSkill( caster , SKILL_EVALINT ) );
	local resist := Cint( GetSkill( cast_on , SKILL_MAGICRESISTANCE ) );
	local chance := Cint( resist / 6);
	local chance2 := Cint( resist - ((magery / 4) + (circle * 8)) );
	
	if( chance2 > chance )
		chance := chance2;
	endif
	
	if( RandomInt(100)+1 <= chance )
		SendSysMessage(cast_on, "You feel yourself resisting magical energy!");
		PlaySoundEffect(cast_on, SFX_SPELL_WEAKEN);
		PlayObjectCenteredEffect( cast_on, FX_SPELL_CURSE, 5,5);
		dmg := Cint( dmg / 2 );
		if( dmg < 1 )
			dmg := 1;
		endif
		SetRawSkill( cast_on , SKILL_MAGICRESISTANCE , GetRawSkill( cast_on , SKILL_MAGICRESISTANCE ) + points );
	endif

	if( resist > evalint )
		dmg := Cint( dmg + ( dmg * (evalint - resist) / 200));
	else
		dmg := Cint( dmg + ( dmg * (evalint - resist) / 500));
	endif

	if( dmg < 1 )
		dmg := 1;
	endif

	return dmg;

endfunction


function CalcSpellDamage ( caster, cast_on , circle )

        local die_string := cstr(circle * 3) +"d5";
	local dmg := RandomDiceRoll( die_string ) ;
	dmg := dmg + Cint( GetSkill(caster, SKILL_MAGERY) / 4 );
        if ( dmg > (circle * 18) )
                dmg := circle * 18;
	endif

	if (!cast_on.npctemplate)
		dmg := dmg / 3;
	endif		

	return dmg;

endfunction


function BurnSelf ( caster , circle )

	local dmg;
	local cast_on := caster;
        dmg := CalcSpellDamage(caster, circle, cast_on);
	ApplyRawDamage( caster , Resisted( caster , circle , cast_on , Cint(dmg / 2) ) );

endfunction


function CanTargetThing ( caster , circle , TargOpt := TGTOPT_CHECK_LOS )

	local cx := caster.x;
	local cy := caster.y;
	local shp := caster.hp;

	if (!can_cast(caster, circle))
        	return 0;
	endif

	local cast_on := Target( caster, TargOpt );
	if(!cast_on)
		return;
	endif

	if ( (cx != caster.x) or (cy != caster.y) or (shp > caster.hp) )
		SendSysMessage(caster,"You've lost your concentration.");
		return 0;
	endif

	return cast_on;	

endfunction


function TryToCast ( caster , spell )

	//Variables declaration and initialisation
	local conf	 := ReadConfigFile("::spells");
	local elem	 := FindConfigElem(conf, spell);
	local circ	 := GetConfigInt(elem, "Circle");
	conf	 	 := ReadConfigFile("::circles");
	local spelldelay := Cint(conf[circ].Delay);
	local value	 := conf[circ].PointValue;
	local manacost	 := conf[circ].Mana;
	local difficulty := GetSpellDifficulty(spell);
        

	//Casting Options management
	local options := GetObjProperty(caster, "CastingOpts");
	if (!options)
		options := GetObjProperty(caster, "PermCastingOpts");
		if( !options)
			options := {};
		else
			options := splitwords( options );
		endif
	else
		options := splitwords( options );
	endif
	

	//Try to cast the spell
	if ( !FindOption( options , "NOWORDS" ) )
                SpeakPowerWords(caster, spell);
	endif

	if ( !FindOption( options , "NODELAY" ) )
		local shp := caster.hp;
		local sx := caster.x;
		local sy := caster.y;
		local sz := caster.z;

		While (spelldelay > 500)
			PerformAction(caster, ANIM_CASTING);
			sleep(1);
			spelldelay := spelldelay - 1000;
			if (caster.hp < shp)
				SendSysmessage( caster , 
						"You were interrupted during the casting" );
				PlayObjectCenteredEffect(caster, FX_SPELL_FIZZLE, SPEED_SPELL_FIZZLE, LOOP_SPELL_FIZZLE );
				PlaySoundEffect(caster, SFX_SPELL_FIZZLE);
				return INTERRUPTED;
			endif

			if (caster.x != sx or caster.y != sy or caster.z != sz)
				SendSysmessage( caster , "You've lost your concentration!" );
				PlayObjectCenteredEffect(caster, FX_SPELL_FIZZLE, SPEED_SPELL_FIZZLE, LOOP_SPELL_FIZZLE );
				PlaySoundEffect(caster, SFX_SPELL_FIZZLE);
				return INTERRUPTED;
			endif
		endwhile

		sleepms(spelldelay);

		if (caster.hp < shp)
			SendSysmessage( caster , 
					"You were interrupted during the casting" );
			PlayObjectCenteredEffect(caster, FX_SPELL_FIZZLE, SPEED_SPELL_FIZZLE, LOOP_SPELL_FIZZLE );
			PlaySoundEffect(caster, SFX_SPELL_FIZZLE);
			return INTERRUPTED;
		endif

		if (caster.x != sx or caster.y != sy or caster.z != sz)
			SendSysmessage( caster , "You've lost your concentration!" );
			PlayObjectCenteredEffect(caster, FX_SPELL_FIZZLE, SPEED_SPELL_FIZZLE, LOOP_SPELL_FIZZLE );
			PlaySoundEffect(caster, SFX_SPELL_FIZZLE);
			return INTERRUPTED;
		endif
	endif

	if ( !FindOption( options , "NOREGS" ) )
                if (!ConsumeReagents(caster, spell))
			PlayObjectCenteredEffect(caster, FX_SPELL_FIZZLE, SPEED_SPELL_FIZZLE , LOOP_SPELL_FIZZLE );
			PlaySoundEffect(caster, SFX_SPELL_FIZZLE);
			SendSysMessage(caster, "Insufficient Reagents.");
			return NO_REGS;
		endif
	endif

	if ( !FindOption( options , "NOMANA" ) )
                if (!ConsumeMana(caster, spell))
			PlayObjectCenteredEffect(caster, FX_SPELL_FIZZLE, SPEED_SPELL_FIZZLE, LOOP_SPELL_FIZZLE);
			PlaySoundEffect(caster, SFX_SPELL_FIZZLE);
			SendSysMessage(caster, "Insufficient Mana.");
			return NO_MANA;
		endif
	endif
			
	if ( !FindOption( options , "NOSKILL" ) )
        	if (!CheckSkill(caster, SKILL_MAGERY, difficulty, value))
			caster.mana := caster.mana + manacost;
			if (caster.mana > caster.maxmana)
				caster.mana := caster.maxmana;
			endif
			PlayObjectCenteredEffect(caster, FX_SPELL_FIZZLE, SPEED_SPELL_FIZZLE, LOOP_SPELL_FIZZLE );
			PlaySoundEffect(caster, SFX_SPELL_FIZZLE);
                        SendSysmessage(caster, "The spell fizzles");
			return NO_SKILL;
		endif
	endif


	return SUCCESS;

endfunction


function FindOption ( options , wantedoption )

	foreach word in options
		if( word = wantedoption )
			return 1;
		endif
	endforeach
	
	return 0;

endfunction


function GetCircle ( spell )

	local conf   	:= ReadConfigFile("::spells");
	local elem   	:= FindConfigElem(conf, spell);
	local circ 	:= GetConfigString(elem, "Circle");
	conf		:= ReadConfigFile("::circles");
	elem		:= FindConfigElem(conf, 24);
	local circle	:= conf[circ].UseCircle;
	if (!circle)
		circle 	:= circ;
	endif
	return Cint(circle);

endfunction


function ctfattacker( cast_on , caster )

	if (!getobjproperty(cast_on, "team")=getobjproperty(caster, "team"))
   		SetObjProperty(cast_on, "CTFLastHit", caster.serial);
	endif

endfunction


function send_attack( ttarget , source , spellid := 0 )
 
 	local ev := array;
 	ev.+type;
 	ev.+source;
 
 	ev.type := 0x0002;
	ev.source := source;
 	SendEvent(ttarget, ev);

 	if (spellid)
         	ev.+spell;
         	ev.type := 0x0800; //spell attack
         	ev.spell := spellid;
         	sendevent(ttarget, ev);
 	endif
 
endfunction


function IsProtected( caster , cast_on , circle )

	local prot := "MagicImmunity";
	local protserial := GetObjProperty( cast_on , "#" + prot );
	local Protlvl := GetObjProperty( cast_on , prot );
	if( !Protlvl )
		Protlvl := 0;
	endif
	
	local PProtlvl := GetObjProperty( cast_on , "Perm" + prot );
	if( !PProtlvl )
		PProtlvl := 0;
	endif
	
	local Cmi := 0 - PProtlvl;
	local item;
	local charges;
	local cursed;
	
	if( protserial )
		foreach thing in ListEquippedItems( cast_on )
			if ( thing.serial = protserial )
				item := thing;
				charges := GetObjProperty( item , prot );
				cursed := GetObjProperty( item , "Cursed" );
				if (!charges)
					eraseobjproperty( cast_on ,"#" + prot );
					eraseobjproperty( item , prot );
					PrintTextAbovePrivate(item , item.desc + " is out of charges!", cast_on );
				endif
				break;
			endif
		endforeach
	endif
	
	if( charges >= circle ) 
		charges := charges - circle;
		setobjproperty( item , prot , charges );
		if( !cursed )
			PrintTextAbovePrivate( cast_on , "Your " + item.desc + " protected you from the spell!" , cast_on );
			return IMMUNED;
		else
			return CURSED;
		endif
		
	elseif( Cmi >= circle )
		return CURSED;
			
	elseif( Protlvl >= circle )
		SetObjProperty( cast_on , prot , Protlvl - circle );
		PrintTextAbovePrivate( cast_on , caster.name + "'s spell is absorbed by your magical protection!" , cast_on );
		PrintTextAbovePrivate( cast_on , "The spell dissipates upon contact with " + cast_on.name + "'s magical barrier!" , caster );
		return IMMUNED;
			
	elseif( PProtlvl >= circle )
		PrintTextAbovePrivate( cast_on , caster.name + "'s spell is absorbed by your magical protection!" , cast_on );
		PrintTextAbovePrivate( cast_on , "The spell dissipates upon contact with " + cast_on.name + "'s magical barrier!" , caster );
		return IMMUNED;
	endif
		
	return 0;
	
endfunction



function ApplyElementalDamage( caster , cast_on , circle , dmg , element )
	
	local resultprot := GetResultingElementalProt( cast_on , element );
	
	if( !resultprot )
		ApplyRawDamage( cast_on , Resisted( caster , cast_on , circle , dmg ) );
	elseif( resultprot <= 4 )
		dmg := dmg - Cint(dmg * resultprot * 25 / 100);
		ApplyRawDamage( cast_on , Resisted( caster , cast_on , circle , dmg ) );
	else
		HealDamage( cast_on , Cint(dmg * (resultprot - 4) * 25 / 100) );
	endif
	
endfunction



function GetResultingElementalProt( cast_on , element )

	local complementary := element - 1;
	if( !complementary )
		complementary := 4;
	endif
	
	local opposed := element + 1;
	if( opposed = 5 )
		opposed := 1;
	endif
	
	local eprot := GetElementalProtLevel( cast_on , element );
	local cprot := GetElementalProtLevel( cast_on , complementary );
	local oprot := GetElementalProtLevel( cast_on , opposed );
	
	if( oprot < 0 )
		oprot := 6 - oprot;
	endif
	
	local resultprot := eprot + Cint(cprot / 2) -  Cint(oprot / 2);
	
	return resultprot;

endfunction



function GetElementalProtLevel( cast_on , element )

	local prot;
	
	case( element )
	
		FIRE:	prot := GetObjProperty( cast_on , "FireProtection" );
			break;
			
		AIR:	prot := GetObjProperty( cast_on , "AirProtection" );
			break;
		
		EARTH:	prot := GetObjProperty( cast_on , "EarthProtection" );
			break;
			
		WATER:	prot := GetObjProperty( cast_on , "WaterProtection" );
			break;
			
	endcase
	
	if( !prot )
		prot := 0;
	endif
	
	return prot;
	
endfunction