////////////////////////////////////////////////////////////////
//
//	CONSTANTS
//
////////////////////////////////////////////////////////////////


//	ListHostiles exclusions

const LH_FLAG_LOS               := 1;       // only include those in LOS
const LH_FLAG_INCLUDE_HIDDEN    := 2;       // include hidden characters


//	ListItemsNearLocationEx exclusions

const LISTEX_FLAG_NORMAL := 0x01;
const LISTEX_FLAG_HIDDEN := 0x02;
const LISTEX_FLAG_GHOST := 0x04;


//	Move Options - add together and pass as "flags" param to
//	MoveCharacterToLocation or MoveItemToLocation

const MOVECHAR_FORCELOCATION := 0x40000000;
const MOVEITEM_NORMAL        := 0;
const MOVEITEM_FORCELOCATION := 0x40000000;


//	SendTextEntryGump options

const TE_CANCEL_DISABLE := 0;
const TE_CANCEL_ENABLE  := 1;

const TE_STYLE_DISABLE  := 0;
const TE_STYLE_NORMAL   := 1;
const TE_STYLE_NUMERICAL:= 2;


//	SystemFindObjectBySerial options:

const SYSFIND_SEARCH_OFFLINE_MOBILES := 1;
const SYSFIND_SEARCH_STORAGE_AREAS   := 2;


//	Target Options - add these together and pass as second
//	param to Target()

const TGTOPT_CHECK_LOS   := 0x0001;
const TGTOPT_NOCHECK_LOS := 0x0000;	// to be explicit
const TGTOPT_HARMFUL     := 0x0002;
const TGTOPT_NEUTRAL     := 0x0000;	// to be explicit
const TGTOPT_HELPFUL     := 0x0004;

// POLCLASS_* constants - use with obj.isa(POLCLASS_*)
const POLCLASS_UOBJECT      := 1;
const POLCLASS_ITEM         := 2;
const POLCLASS_MOBILE       := 3;
const POLCLASS_NPC          := 4;
const POLCLASS_LOCKABLE     := 5;
const POLCLASS_CONTAINER    := 6;
const POLCLASS_CORPSE       := 7;
const POLCLASS_DOOR         := 8;
const POLCLASS_SPELLBOOK    := 9;
const POLCLASS_MAP          := 10;
const POLCLASS_MULTI        := 11;
const POLCLASS_BOAT         := 12;
const POLCLASS_HOUSE        := 13;
const POLCLASS_EQUIPMENT    := 14;
const POLCLASS_ARMOR        := 15;
const POLCLASS_WEAPON       := 16;


// Don't use these outside this file, use FONT_* from client.inc
//  (and I don't know what for color)
const _DEFAULT_TEXT_FONT     := 3;
const _DEFAULT_TEXT_COLOR    := 0x3B2;

////////////////////////////////////////////////////////////////
//
//	FUNCTIONS
//
////////////////////////////////////////////////////////////////

Accessible( by_character, item );
AddMenuItem( menu, objtype, text );
ApplyConstraint( objlist, configfile, propertyname, minvalue );
ApplyDamage( mobile, damage );
ApplyRawDamage( character, hits ); // raw damage (ignores armor etc)
AssignRectToWeatherRegion( region, xwest, ynorth, xeast, ysouth );
AwardRawPoints( mobile, skillid, rawpoints );
BaseSkillToRawSkill( baseskill );
Broadcast( text, font := _DEFAULT_TEXT_FONT, color := _DEFAULT_TEXT_COLOR );
CheckLineOfSight( object1, object2 );
CheckLosAt( character, x, y, z );
CheckSkill( character, skillid, difficulty, points );
ConsumeMana( who, spellid );
ConsumeReagents( who, spellid );
ConsumeSubstance( container, objtype, amount );
CreateAccount( acctname, password, enabled );
CreateItemAtLocation( x, y, z, objtype, amount );
CreateItemInBackpack( of_character, objtype, amount := 1 );
CreateItemInContainer( container, objtype, amount := 1 );
CreateItemInInventory( container, objtype, amount := 1 );
CreateMenu( title );
CreateMultiAtLocation( x, y, z, objtype );
CreateNpcFromTemplate( template, x, y, z, override_properties := 0);
CreateRootItemInStorageArea( area, itemname, objtype );
CreateStorageArea( areaname );
Damage( character, hits );	// deprecated, syn. for ApplyRawDamage
DestroyRootItemInStorageArea( area, itemname );
DestroyItem( item );
DestroyMulti( multi );
Detach();
DisableEvents( eventtype );
DisconnectClient( character );
Distance( obj1, obj2 );
EnableEvents( eventtype, range := -1);
EnumerateItemsInContainer( container );
EnumerateOnlineCharacters();
EquipFromTemplate( character, template ); // reads from equip.cfg
EquipItem( mobile, item );
EraseGlobalProperty( propname );
EraseObjProperty( object, propname );
FindAccount( acctname );
FindObjtypeInContainer( container, objtype );
FindRootItemInStorageArea( area, itemname );
FindStorageArea( areaname );
GameStat(name);		// deprecated
GetAmount( item );
GetCommandHelp( character, command );
GetEquipmentByLayer( character, layer );
GetGlobalProperty( propname );
GetHarvestDifficulty( resource, x, y, tiletype );
GetMapInfo( x, y );
GetMenuObjTypes( menuname );
GetObjProperty( object, property_name );
GetObjPropertyNames( object );
GetObjType( object );
GetObjtypeByName( name );
GetRawSkill( character, skillid );
GetRegionString( resource, x, y, propertyname );
GetSkill( character, skillid );
GetSpellDifficulty( spellid );
GetStandingHeight( x, y, startz );
GetWorldHeight( x, y );
GrantPrivilege( character, privilege );
HarvestResource( resource, x, y, b, n ); // returns b*a where 0 <= a <= n
HealDamage( character, hits );
ListAccounts( );
ListEquippedItems( who );
ListGhostsNearLocation( x, y, z, range );
ListHostiles( character, range := 20, flags := 0 );
ListItemsAtLocation( x, y, z );
ListItemsNearLocation( x, y, z, range );
ListItemsNearLocationOfType( x,y,z, range, objtype );
ListMobilesInLineOfSight( object, range );
ListMobilesNearLocation( x, y, z, range );
ListMobilesNearLocationEx( x,y,z, range, flags );
ListObjectsInBox( x1,y1,z1, x2,y2,z2 );
MoveCharacterToLocation( character, x, y, z, flags := 0 );
MoveItemToContainer( item, container, x := -1, y := -1 );
MoveItemToLocation( item, x, y, z, flags );
OpenPaperdoll( towhom, forwhom );
PerformAction( character, action );
PlayLightningBoltEffect( center_object );
PlayMovingEffect( source, target, effect, speed, loop := 0, explode := 0 );
PlayMovingEffectXYZ( srcx, srcy, srcz, dstx, dsty, dstz, effect, speed, loop := 0, explode := 0 );
PlayObjectCenteredEffect( center, effect, speed, loop := 0 );
PlaySoundEffect( character, effect );
PlaySoundEffectPrivate( character, effect, playfor );
PlayStationaryEffect( x, y, z, effect, speed, loop := 0, explode := 0 );
polcore();
PrintTextAbove( above_object, text, font := _DEFAULT_TEXT_FONT, color := _DEFAULT_TEXT_COLOR ); 
PrintTextAbovePrivate( above_object, text, character, font := _DEFAULT_TEXT_FONT, color := _DEFAULT_TEXT_COLOR );
RawSkillToBaseSkill( rawskill );
ReadGameClock();
RegisterForSpeechEvents( at_object, range );
ReleaseItem( item );
RequestInput( character, item, prompt ); // item is a placeholder, just pass any item
ReserveItem( item );
RestartScript( npc );
Resurrect( mobile );
RevokePrivilege( character, privilege );
SaveWorldState();
SelectMenuItem2( character, menuname );
SendBuyWindow( character, container, vendor, items );
SendDialogGump( who, layout, textlines );
SendEvent( npc, event );
SendInstaResDialog( character );
SendOpenSpecialContainer( character, container );
SendPacket( to_whom, packet_hex_string );
SendSellWindow( character, vendor, i1, i2, i3 );
SendSkillWindow( towhom, forwhom );
SendStringAsTipWindow( character, text );
SendSysMessage( character, text, font := _DEFAULT_TEXT_FONT, color := _DEFAULT_TEXT_COLOR );
SendTextEntryGump( who, line1, cancel := TE_CANCEL_ENABLE, style := TE_STYLE_NORMAL, maximum := 40, line2 := "" );
SendViewContainer( character, container );
SetGlobalProperty( propname, propval );
SetName( object, name );
SetObjProperty( object, property_name, property_value_string_only );
SetRawSkill( character, skillid, rawskill );
SetRegionLightLevel( regionname, lightlevel );
SetRegionWeatherLevel( region, type, severity, aux := 0, lightoverride := -1);
SetScriptController( who );
Shutdown();
SpeakPowerWords( who, spellid );
StartSpellEffect( who, spellid );
SubtractAmount( item, amount );
SystemFindObjectBySerial( serial, sysfind_flags := 0 );
Target( by_character, options := TGTOPT_CHECK_LOS+TGTOPT_NEUTRAL);
TargetCoordinates( by_character );
TargetMultiPlacement( character, objtype );

