use uo;

include "include/client";

function repair_item( character , item , skillid )

	local damaged 	:= item.maxhp - item.hp;
	local skill 	:= GetSkill( character , skillid );
	local armslore 	:= GetSkill( character , SKILLID_ARMSLORE );
	local diff 	:= Cint((item.quality + 0.5) * damaged);


	//The item should be broken already
	if ((item.hp < 1) or (item.hp > item.maxhp ) or (item.quality <= 0.1) or (!item.quality))
		SendSysmessage(character, "The brittle material breaks when you handle it!");
		DestroyItem( item );
		return;
	endif

	//Check if the item is damaged
	if( item.hp = item.maxhp )
		SendSysmessage( character , "That item is in perfect condition already." );
		return;
	endif
	
	//Check if you have a chance to repair it
	if( armslore >= damaged )
	
		//Check if he repair it
		if (CheckSkill( character , skillid , diff , 10 ))

			//Check for a special effect
			local chance := RandomInt(100) + 1;
			
			//Bad luck, destroyed (and prevent skill gain from macro repair)
			if( chance <= 5 )
				SendSysmessage( character, "You fail and destroy the item" );
				DestroyItem( item );
				return;
				
			//Good luck, the item's quality improve
			elseif( chance = 100 )
				SendSysmessage( character , "Your chance and skill improved the quality of the item!" );
				item.quality := item.quality + 0.05;
				item.hp := item.maxhp;
				return;
			
			//Bad luck, the item get damaged
			elseif( chance <= 10 )
				local dmg := Cint(damaged / 8);
				if( dmg < 1 )
					dmg := 1;
				endif
				
				if( dmg >= item.hp )
					SendSysmessage( character, "You fail and destroy the item" );
					DestroyItem( item );
				else
					SendSysmessage( character , "You fail in your repairing attempt and damage the item!" );
					item.hp := item.hp - dmg;
				endif
				return;
				
			//You repair the item
			else
				local amount := Cint((RandomInt(armslore)+1) / 2 );
				if( amount >= damaged )
					item.hp := item.maxhp;
					SendSysmessage (character, "You repair the item completely.");
				else
					item.hp := item.hp + amount;	
					SendSysmessage (character, "You successfully repair some of the damage");
				endif
				return;
			endif
		
		//You fail to repair it	
		else
			local dmg := Cint(damaged / 4);
			if( dmg < 1 )
				dmg := 1;
			endif
				
			if( dmg >= item.hp )
				SendSysmessage( character, "You fail and destroy the item" );
				DestroyItem( item );
			else
				SendSysmessage( character , "You fail in your repairing attempt and damage the item!" );
				item.hp := item.hp - dmg;
			endif
			return;
		endif
	
	//You didn't even had a chance to repair it	
	else
		local dmg := Cint(damaged / 6);
		if( dmg < 1 )
			dmg := 1;
		endif
			
		if( dmg >= item.hp )
			SendSysmessage( character, "You fail and destroy the item" );
			DestroyItem( item );
		else
			SendSysmessage( character , "You fail in your repairing attempt and damage the item!" );
			item.hp := item.hp - dmg;
		endif
		return;
	endif
	

endfunction
